import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

//t@Co
public class Kubomaki2FileIO {
	//
	JFrame frame;
	//
	Kubomaki2Panel panel;
	//
	JFileChooser chooser;
	//
	File saveFile,preFile;
	//
	//------------------------------------------------
	//
	//------------------------------------------------
	public Kubomaki2FileIO(JFrame fr,Kubomaki2Panel p){
		//
		frame=fr;
		//
		panel=p;
		//vOfBNglɂč쐬
		chooser=new JFileChooser(".");
		//
		saveFile=preFile=null;
	}

	//******************************************************************************************************
	//[h
	//------------------------------------------------------------------------------------------------------
	public void load(Kubomaki2Make make){
		//[ht@C̃pX𓾂
		if(!getTargetFile("Z[ut@C(*.txt)J","J",saveFile,false)){	//[hȂȂI
			return;
		}
		//t@Cǂݍ
		String[] fileString=readTextFile(preFile);
		if(fileString==null){
			panel.showErrorMessage("t@Cǂݍ݂Ɏs܂B","");
			return;
		}
		//[hf[^𓖂Ă͂߂
		make.setLoadString(deleteExtension(preFile.getName()),fileString);
		/*	̃vOł̓f[^̃`FbN͂Ȃ
		if(!make.setLoadString(fileString)){
			panel.showErrorMessage("f[^܂B","");
			return;
		}*/
		//Z[ut@Ci[
		saveFile=preFile;
	}
	//t@CgqiXe[W𓾂邽߁j
	private static String deleteExtension(String s){
		int period=s.lastIndexOf(".");
		if(period!=-1){
			return s.substring(0,period);

		}else{
			return s;
		}
	}
	//******************************************************************************************************
	//Z[u
	//------------------------------------------------------------------------------------------------------
	//㏑ۑ
	/*	̃vOł͕sv
	public void save(KubomakiMake make){
		if(saveFile!=null){
			savePuzzleData(saveFile,make);
		}else{	//Z[ut@C񂪂ȂΖOtĕۑ
			saveAs(make);
		}
	}*/
	//Otĕۑ
	public void saveAs(Kubomaki2Make make){
		//Z[ut@C̃pX𓾂
		if(getTargetFile("Z[ut@C(*.txt)ɕۑ","ۑ",saveFile,true)){
			//gqtĂȂΕt
			preFile=addExtension(preFile,"txt");
			//
			savePuzzleData(preFile,make);
		}
	}
	//Z[ut@C󂯎ăZ[us
	private void savePuzzleData(File file,Kubomaki2Make make){
		//Z[us
		if(!writeTextFile(file,make.getSaveString())){
			panel.showErrorMessage("t@C݂Ɏs܂B","");
			return;
		}
		//Z[ut@Ci[
		saveFile=preFile;
	}
	//******************************************************************************************************
	//t@C
	//------------------------------------------------------------------------------------------------------
	//ΏۂƂȂt@C擾i擾trueԂj
	private boolean getTargetFile(String title,String button,File file,boolean overwrite){
		chooser.setSelectedFile(file);
		//
		chooser.setDialogTitle(title);
		//ꎞt@CɎ擾
		File tmpFile;
		while (true) {
			if (chooser.showDialog(frame,button) != JFileChooser.APPROVE_OPTION) {
				return false;
			}
			tmpFile = chooser.getSelectedFile();
			//㏑mFKvȂ炷
			if(!overwrite){	break;	}
			if (tmpFile.exists()) {
				switch (JOptionPane.showConfirmDialog(frame,tmpFile.getName()+" ͊ɑ݂܂B\n㏑܂H","mF",JOptionPane.YES_NO_CANCEL_OPTION)){
					case JOptionPane.YES_OPTION:
						break;
					case JOptionPane.NO_OPTION:
						continue;
					case JOptionPane.CANCEL_OPTION:
						return false;
				}
				break;
			} else {
				break;
			}
		}
		//Ă͂
		preFile=tmpFile;
		return true;
	}
	//t@CɎw肳ꂽgqtĂȂΕt
	private File addExtension(File file,String... extension){
		//gqmF
		int period=file.getPath().lastIndexOf(".");
		if(period!=-1){
			for(int e=0;e<extension.length;e++){
				if(file.getPath().substring(period).equals("."+extension[e])){
					return file;	//̊gqtĂ
				}
			}
			//w肳ꂽgqǂtĂȂ
			return new File(file.getPath()+"."+extension[0]);
		}else{	//ŏ牽̊gqtĂȂ
			return new File(file.getPath()+"."+extension[0]);
		}
	}
	//******************************************************************************************************
	//eLXgt@Co
	//------------------------------------------------------------------------------------------------------
	//w肳ꂽeLXgt@CǂݍœeԂ
	private static String[] readTextFile(File file){
		try{
			ArrayList<String> stringArray=new ArrayList<String>();
			String line;
			//
			BufferedReader br=new BufferedReader(new FileReader(file));
			while((line=br.readLine())!=null){
				stringArray.add(line);
			}
			br.close();
			//
			String[] ret=new String[stringArray.size()];
			for(int i=0;i<stringArray.size();i++){
				ret[i]=stringArray.get(i);
			}
			return ret;
		}catch(Exception e){
			return null;
		}
	}
	//eLXgf[^t@Cɕۑ
	public static boolean writeTextFile(File file,String data){
		try{
			PrintWriter pw=new PrintWriter(new BufferedWriter(new FileWriter(file)));
			pw.print(data);
			pw.close();
			return true;
		}catch(Exception e){
			return false;
		}
	}
}
