//---------------------------------------------
//̈̋
//---------------------------------------------
public class Kubomaki2Balldata
{
	//
	int posx;
	int posy;
	int posz;
	//`p
	double xx_ratio;	//w
	double yy_ratio;	//x
	double radius_ratio;//a
	//
	public Kubomaki2Balldata(int x,int y,int z){
		//
		posx=x;
		posy=y;
		posz=z;
		xx_ratio=0;
		yy_ratio=0;
		radius_ratio=0;
	}
	//------------------------------------------------------
	//`p̌vZ
	//------------------------------------------------------
	public void setView(Kubomaki2Self self,int ball_space,int view_depth,int view_height){
		//
		double tmpx=ball_space*posx-self.posx;
		double tmpy=ball_space*posy-self.posy;
		//
		double viewx;
		double viewy;
		double viewz;
		//
		viewx=tmpx*Math.cos(-self.angle*Math.PI/180)-tmpy*Math.sin(-self.angle*Math.PI/180);
		//
		if(viewx>=0 && viewx<=view_depth*ball_space){
			//
			viewy=tmpx*Math.sin(-self.angle*Math.PI/180)+tmpy*Math.cos(-self.angle*Math.PI/180);
			viewz=ball_space*posz-self.posz;
			//
			xx_ratio=(1-(view_depth*viewy)/(view_height*viewx))/2;
			yy_ratio=(1-(view_depth*viewz)/(view_height*viewx*1.6))/2;
			radius_ratio=1-Math.sqrt( viewx*viewx+viewy*viewy+viewz*viewz )/(view_depth*ball_space);
			if(radius_ratio<0){
				radius_ratio=0;
			}
		}else{
			radius_ratio=0;
		}
	}
}
