import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.util.ArrayList;

import javax.swing.JPanel;
import javax.swing.Timer;
//
public class Kubomaki2Play extends JPanel implements ActionListener {
	//===============================================萔
	//ԁimodePlayj\萔
	static final int MP_START=0;
	static final int MP_WAIT=1;
	static final int MP_PLAY=2;
	static final int MP_REST=3;
	static final int MP_OVER=4;
	static final int MP_CLEAR=5;
	//ʂ̎
	static final byte B_NONE=0;	//
	static final byte B_WHITE=1;	//{i_j
	static final byte B_RED=2;	//
	static final byte B_GREEN=3;	//
	static final byte B_BLUE=4;	//
	static final byte B_END=5;	//
	//tF[h̎
	static final int F_IN=0;		//
	static final int F_OUT=1;		//
	static final int F_INOUT=2;	//
	static final int F_OUTIN=3;	//
	//p݈̌ʒu
	static final int P_HOME=0;
	static final int P_IN_AREA=1;
	static final int P_OUT_AREA=2;
	static final int P_LAND=3;
	//
	//
	static final int PU=(int)(Kubomaki2Panel.F_WIDTH/32);
	//tHg
	static final Font FONT_M_P=new Font(null,Font.PLAIN,PU);
	static final Font FONT_M_B=new Font(null,Font.BOLD,PU);
	static final Font FONT_L_B=new Font(null,Font.BOLD,PU*3);
	//===============================================ϐ
	//
	Kubomaki2Panel panel;
	Kubomaki2Data data;	//ݒǂݍ
	Kubomaki2Sound sounds;	//BGMEʉ
	//
	//-------------IuWFNg---------------------
	//@
	Kubomaki2Self self;
	//ʊ֌W
	Kubomaki2Balls balls;
	//----------------ϐ-------------------------
	//ball΂܂Ԃ̑傫
	int space_max;
	//`p̋ʂ̑傫i0̎̑傫j
	int view_radius;
	//runsleep~b
	int time_play;	//
	int time_fade;	//tF[h̎
	//tF[h
	boolean fade_flag;
	Color fade_color;
	int fade_max;
	int fade_now;
	int fade_step;
	boolean fade_continue;
	//
	int ball_max;	//W߂ȂĂ͂Ȃ
	int ball_num;	//̌
	//~ov
	int help_max;	//
	int help;		//ɂ
	//
	int timer_minite;		//
	double timer_second;	//
	int timer_limit;	//
	//x\̃tO
	boolean timer_flag;	//
	boolean power_flag;	//
	boolean area_flag;	//
	//
	int star_speed;
	int star_num;
	Rectangle star1_rect;
	Dimension star1[];
	Rectangle star2_rect;
	Dimension star2[];
	//L[Cxg̃tO
	boolean absorb;
	boolean go_up;
	boolean go_down;
	boolean go_ahead;
	boolean go_back;
	boolean turn_left;
	boolean turn_right;
	//
	//`p
	int pox;
	int poy1;
	int poy2;
	int pr1;
	int pr2;
	int px1[];
	int px2[];
	int py[];
	//
	//̏
	int modePlay;
	//
	Timer timerPlay;
	//------------------------------------------------
	//RXgN^
	//------------------------------------------------
	public Kubomaki2Play(Kubomaki2Panel p,Kubomaki2Data d,Kubomaki2Sound s)
	{
		//
		panel=p;
		data=d;
		sounds=s;
		//
		/*
		//*********p************
		//ԁiŎwj
		timer_minite=data.timeLimit;
		//Ԍx\ic蕪j
		timer_limit=data.timeAlert;
		//ĕ`Ԋui~bŎwj
		time_play=data.repaintIntervalPlay;	//oq
		time_fade=data.repaintIntervalFade;	//tF[hCEtF[hAEg
		//ʂ΂܂Ԃ̑傫
		space_max=data.areaSize;
		//ʂɍł߂Â̍ő`攼a
		view_radius=data.colorballPaintradius;
		//W߂鍇ʂ̌
		ball_max=data.ballNumber;
		//vł~M̉
		help_max=data.helpNumber;
		//
		//***************************
		*/
		//
		absorb=false;
		go_up=false;
		go_down=false;
		go_ahead=false;
		go_back=false;
		turn_left=false;
		turn_right=false;
		//
		fade_flag=false;
		fade_color=Color.white;
		//------------
		//formatData();
		//
		//`p
		pox=16*PU;
		poy1=-60*PU;
		poy2=68*PU;
		pr1=(int)(Math.sqrt(pox*pox+poy1*poy1));
		pr2=(int)(Math.sqrt(pox*pox+48*PU*48*PU));
		px1=new int[4];
		px2=new int[4];
		py=new int[4];
		px1[0]=1*PU;	py[0]=0;
		px1[1]=6*PU;	py[1]=Kubomaki2Panel.F_HEIGHT;
		px1[2]=8*PU;	py[2]=Kubomaki2Panel.F_HEIGHT;
		px1[3]=3*PU;	py[3]=0;
		px2[0]=Kubomaki2Panel.F_WIDTH-1*PU;
		px2[1]=Kubomaki2Panel.F_WIDTH-6*PU;
		px2[2]=Kubomaki2Panel.F_WIDTH-8*PU;
		px2[3]=Kubomaki2Panel.F_WIDTH-3*PU;
		//
		star_speed=(int)(PU/25);
		/*
		if(star_speed==0){	star_speed=1; }
		*/
		star_num=15;
		star1_rect=new Rectangle(0,0,6*PU,20*PU);
		star2_rect=new Rectangle(26*PU,0,6*PU,20*PU);
		star1=new Dimension[star_num];
		star2=new Dimension[star_num];
		for(int i=0;i<star_num;i++){
			star1[i]=new Dimension( (int)((star1_rect.getSize()).width*Math.random()) ,
									(int)((star1_rect.getSize()).height*Math.random()) );
			star2[i]=new Dimension( (int)((star2_rect.getSize()).width*Math.random()+(star2_rect.getLocation()).x) ,
									(int)((star2_rect.getSize()).height*Math.random()) );
		}
		//
		timerPlay=new Timer(time_play,this);
		//Ԃ̓^Cg
		modePlay=MP_START;
	}
	//---------------------------------------------------
	//f[^̏AăX^[g̎ɂĂяo
	//---------------------------------------------------
	private void formatData(){
		//
		ball_num=0;
		//
		help=0;
		//@
		self=new Kubomaki2Self(data);
		//
		balls=new Kubomaki2Balls(data,self,space_max);
		//
		timer_second=timer_minite*60;
		//
		timer_flag=false;
		power_flag=false;
		area_flag=false;
	}
	public void formatStage(){
		//
		sounds.formatSound(data);
		//
		//*********p************
		//ԁiŎwj
		timer_minite=data.timeLimit;
		//Ԍx\ic蕪j
		timer_limit=data.timeAlert;
		//ĕ`Ԋui~bŎwj
		time_play=data.repaintIntervalPlay;	//oq
		time_fade=data.repaintIntervalFade;	//tF[hCEtF[hAEg
		//ʂ΂܂Ԃ̑傫
		space_max=data.areaSize;
		//ʂɍł߂Â̍ő`攼a
		view_radius=data.colorballPaintradius;
		//W߂鍇ʂ̌
		ball_max=data.ballNumber;
		//vł~M̉
		help_max=data.helpNumber;
		//***************************
		//
		//
		//formatData();
		//
		//itF[hԊúj
		//
		//Ԃ^CgʂɂĂaflJn
		modePlay=MP_START;
		sounds.loopBGM(Kubomaki2Sound.BGM_OPEN);
	}
	//------------------------------------------------
	//`pɎc莞Ԃ𕶎Ŏ擾
	//------------------------------------------------
	private String getTimeString(){
		int t;
		//
		StringBuilder ret=new StringBuilder();
		t=(int)(timer_second/60);
		ret.append((t<10)?"0":"").append(Integer.toString(t)).append(":");
		t=(int)(timer_second%60);
		ret.append((t<10)?"0":"").append(Integer.toString(t)).append(".");
		t=(int)((timer_second*100)%100);
		ret.append((t<10)?"0":"").append(Integer.toString(t));
		//
		return ret.toString();
	}
	//---------------------------------------------------
	//`
	//---------------------------------------------------
	public void paint(Graphics g){
		//
		//******************************************************
		if(fade_flag){
			//hԂ
			g.setColor(fade_color);
			g.fillRect(0, 0, Kubomaki2Panel.F_WIDTH, Kubomaki2Panel.F_HEIGHT);
		//******************************************************
		}else if( modePlay==MP_PLAY || modePlay==MP_WAIT || modePlay==MP_REST ){
			//wiFœhԂ
			g.setColor(Color.black);
			g.fillRect(0, 0, Kubomaki2Panel.F_WIDTH, Kubomaki2Panel.F_HEIGHT);
			//
			g.setColor(Color.white);
			for(int i=0;i<star_num;i++){
				g.fillOval(star1[i].width,star1[i].height,3,3);	//
				g.fillOval(star2[i].width,star2[i].height,3,3);	//E
			}
			//Oʂ̃j^[猩ǑiF
			if(balls.nearColor()!=B_NONE){	//ʂ̒ɂꍇ
				//
				switch(balls.nearColor()){
				case 2:	//red
					g.setColor( new Color(255 ,0,0) );
					break;
				case 3:	//green
					g.setColor( new Color(0, 255 ,0) );
					break;
				case 4:	//blue
					g.setColor( new Color(0,0, 255 ) );
					break;
				case 1:	//white
					g.setColor( new Color( 255 , 255, 255) );
					break;
				}
				g.fillRect(0, 0, Kubomaki2Panel.F_WIDTH, Kubomaki2Panel.F_HEIGHT);	//
			}else{						//ʂ̒ɂȂꍇ
				ArrayList<Kubomaki2Balldata> v=balls.area_data;
				for(int i=0;i<v.size();i++){
					Kubomaki2Balldata b=v.get(i);
					int r=(int)(b.radius_ratio*view_radius*PU);
					if( b.radius_ratio!=0 ){
						switch(balls.ball[balls.ball_max+b.posx][balls.ball_max+b.posy][balls.ball_max+b.posz]){
						case B_RED:	//red
							g.setColor( new Color( (int)(255*b.radius_ratio) ,0,0) );
							break;
						case B_GREEN:	//green
							g.setColor( new Color(0, (int)(255*b.radius_ratio) ,0) );
							break;
						case B_BLUE:	//blue
							g.setColor( new Color(0,0, (int)(255*b.radius_ratio) ) );
							break;
						case B_WHITE:	//white
							g.setColor( new Color( (int)(255*b.radius_ratio) , (int)(255*b.radius_ratio) , (int)(255*b.radius_ratio) ) );
							break;
						}
						g.fillOval((int)(b.xx_ratio*32*PU)-r,
											(int)(b.yy_ratio*20*PU)-r,
											2*r, 2*r);
					}
					//
				}
			}
			//
			g.setColor(Color.lightGray);
			//V
			g.fillOval(pox-pr1, poy1-pr1, 2*pr1, 2*pr1);
			//\pl
			g.fillOval(pox-pr2, poy2-pr2, 2*pr2, 2*pr2);
			//
			g.fillPolygon(px1,py,4);
			g.fillPolygon(px2,py,4);
			//͂̌x
			if( self.checkPower() ){
				g.setColor(Color.black);
				g.fillRoundRect(0*PU,1*PU,4*PU,2*PU,PU,PU);
				g.setColor(Color.lightGray);
				g.drawRoundRect(0*PU,1*PU,4*PU,2*PU,PU,PU);
				g.drawRoundRect(0*PU+1,1*PU+1,4*PU-2,2*PU-2,PU,PU);
				power_flag=false;
			}else{
				g.setColor(Color.black);
				g.fillRoundRect(0*PU,1*PU,4*PU,2*PU,PU,PU);
				g.setColor(Color.red);
				g.drawRoundRect(0*PU,1*PU,4*PU,2*PU,PU,PU);
				g.drawRoundRect(0*PU+1,1*PU+1,4*PU-2,2*PU-2,PU,PU);
				g.setFont(FONT_M_B);
				g.drawString(" Power",0*PU,2*PU);
				g.drawString("  Empty",0*PU,3*PU);
				if(!power_flag){
					power_flag=true;
					sounds.playSE(Kubomaki2Sound.SE_ALERT);
				}
			}
			//Ԃ̌x
			if(timer_second>60*timer_limit){
				g.setColor(Color.black);
				g.fillRoundRect(1*PU,4*PU,3*PU,2*PU,PU,PU);
				g.setColor(Color.lightGray);
				g.drawRoundRect(1*PU,4*PU,3*PU,2*PU,PU,PU);
				g.drawRoundRect(1*PU+1,4*PU+1,3*PU-2,2*PU-2,PU,PU);
			}else{
				g.setColor(Color.black);
				g.fillRoundRect(1*PU,4*PU,3*PU,2*PU,PU,PU);
				g.setColor(Color.red);
				g.drawRoundRect(1*PU,4*PU,3*PU,2*PU,PU,PU);
				g.drawRoundRect(1*PU+1,4*PU+1,3*PU-2,2*PU-2,PU,PU);
				g.setFont(FONT_M_B);
				g.drawString(" Time",1*PU,5*PU);
				g.drawString(" Limit",1*PU,6*PU);
				if(!timer_flag){
					timer_flag=true;
					sounds.playSE(Kubomaki2Sound.SE_ALERT);
				}
			}
			//GAǑx
			if(balls.area_pos!=P_OUT_AREA){
				g.setColor(Color.black);
				g.fillRoundRect(2*PU,7*PU,3*PU,2*PU,PU,PU);
				g.setColor(Color.lightGray);
				g.drawRoundRect(2*PU,7*PU,3*PU,2*PU,PU,PU);
				g.drawRoundRect(2*PU+1,7*PU+1,3*PU-2,2*PU-2,PU,PU);
				area_flag=false;
			}else{
				g.setColor(Color.black);
				g.fillRoundRect(2*PU,7*PU,3*PU,2*PU,PU,PU);
				g.setColor(Color.red);
				g.drawRoundRect(2*PU,7*PU,3*PU,2*PU,PU,PU);
				g.drawRoundRect(2*PU+1,7*PU+1,3*PU-2,2*PU-2,PU,PU);
				g.setFont(FONT_M_B);
				g.drawString(" Area",2*PU,8*PU);
				g.drawString("  Out",2*PU,9*PU);
				if(!area_flag){
					area_flag=true;
					sounds.playSE(Kubomaki2Sound.SE_ALERT);
				}
			}
			//[^[iqɏjobN
			g.setColor(Color.black);
			g.fillOval(11*PU,18*PU,4*PU,4*PU);	//direct
			g.fillRoundRect(16*PU,22*PU,15*PU,1*PU,PU,PU);	//power
			g.fillRoundRect(9*PU,19*PU,1*PU,4*PU,PU,PU);	//high
			g.fillArc(17*PU,19*PU,4*PU,4*PU,0,180);	//in
			g.fillArc(22*PU,19*PU,4*PU,4*PU,0,180);	//out
			g.fillRect(12*PU,0*PU,4*PU,1*PU);	//timer
			//\pl̕
			g.setFont(FONT_M_P);
			g.drawString("  in",18*PU,22*PU);
			g.drawString(" out",23*PU,22*PU);
			g.drawString("  E",16*PU,24*PU);
			g.drawString("  F",29*PU,24*PU);
			g.drawString(" high",8*PU,24*PU);
			g.drawString("  direct",11*PU,23*PU);
			g.setFont(FONT_M_B);
			g.drawString("Power",22*PU,24*PU);
			g.drawString("Position",11*PU,24*PU);
			g.drawString(" Store",1*PU,24*PU);
			//
			g.setColor(Color.white);
			g.drawString(getTimeString(),12*PU,1*PU);
			//ʒ̏ԕ\
			switch(modePlay){
			case MP_PLAY:	//play
				break;
			case MP_WAIT:	//wait
				g.setColor(Color.pink);
				g.setFont(FONT_L_B);
				g.drawString("ҋ@",11*PU,9*PU);
				g.setFont(FONT_M_B);
				g.drawString("  WʐF"+ball_num+"/"+ball_max+" ",11*PU,11*PU);
				g.drawString("  ~vF"+help+"/"+help_max+" ",11*PU,12*PU);
				g.setColor(Color.gray);
				g.drawString("EnterL[ŏoq",12*PU,14*PU);
				break;
			case MP_REST:	//rest
				g.setColor(Color.orange);
				g.setFont(FONT_L_B);
				g.drawString("xe",11*PU,9*PU);
				g.setFont(FONT_M_B);
				g.drawString("  WʐF"+ball_num+"/"+ball_max+" ",11*PU,11*PU);
				g.drawString("  ~vF"+help+"/"+help_max+" ",11*PU,12*PU);
				g.setColor(Color.lightGray);
				g.drawString("SpaceL[ŃQ[ĊJ",10*PU,14*PU);
				break;
			}
			//[^[iqɏj
			g.setColor(Color.white);
			g.drawOval(11*PU,18*PU,4*PU,4*PU);	//direct
			g.drawOval(12*PU,19*PU,2*PU,2*PU);
			g.drawLine(13*PU,18*PU,13*PU,22*PU);
			g.drawLine(11*PU,20*PU,15*PU,20*PU);
			g.drawRoundRect(16*PU,22*PU,15*PU,1*PU,PU,PU);	//power
			g.drawRoundRect(9*PU,19*PU,1*PU,4*PU,PU,PU);	//high
			g.drawLine(9*PU,21*PU,10*PU,21*PU);
			g.drawArc(17*PU,19*PU,4*PU,4*PU,0,180);	//in
			g.drawArc(22*PU,19*PU,4*PU,4*PU,0,180);	//out
			g.drawRect(12*PU,0*PU,4*PU,1*PU);	//timer
			//high
			g.setColor(Color.red);
			int h;
			if(Math.abs(self.posz)<space_max){
				h=(int)((2*PU)*self.posz/space_max);
			}else{
				if(self.posz>0){	h=2*PU;		}
				else{				h=-2*PU;	}
			}
			g.drawLine(9*PU,21*PU-h-1,10*PU,21*PU-h-1);
			g.drawLine(9*PU,21*PU-h,10*PU,21*PU-h);
			g.drawLine(9*PU,21*PU-h+1,10*PU,21*PU-h+1);
			//direct
			double rr=Math.sqrt(self.posx*self.posx+self.posy*self.posy);	//a
			if(rr>space_max){
				rr=space_max;
			}
			double rad;
			if(rr!=0){
				if(self.posy>0){
					rad=(90+180-self.angle)*Math.PI/180+Math.acos(self.posx/rr);	//px
				}else{
					rad=(90+180-self.angle)*Math.PI/180-Math.acos(self.posx/rr);	//px
				}
			}else{
				rad=0;
			}
			g.setColor(Color.white);
			g.fillOval( (int)(13*PU+(2*PU)*Math.cos(rad)*rr/space_max)-3 ,
					 (int)(20*PU-(2*PU)*Math.sin(rad)*rr/space_max)-3 ,6,6);	//{D
			g.setColor(Color.red);
			g.fillOval( 13*PU-3 ,
					 20*PU-3 ,6,6);												//
			//power
			g.setColor(Color.yellow);
			g.fillRoundRect(16*PU,22*PU,(int)(15*PU*self.power/self.power_max),1*PU,PU,PU);	//power
			g.fillArc(17*PU,19*PU,4*PU,4*PU,180,-(int)(180*self.power_in));	//in
			g.fillArc(22*PU,19*PU,4*PU,4*PU,180,-30*self.power_out);	//out
			//{Di_jv
			if(self.radius<=2*balls.ball_space){
				g.setColor(Color.orange);
			}else{
				g.setColor(Color.gray);
			}
			g.fillOval(19*PU,0*PU,PU,PU);
			g.setColor(Color.white);
			g.drawOval(19*PU,0*PU,PU,PU);
			//qɃobNEe
			if(self.ball_all>0){
				g.setColor(Color.gray);
				g.fillRoundRect(4*PU,20*PU,3*PU,4*PU,PU,PU);	//
				g.setColor(Color.darkGray);
				g.fillRoundRect(4*PU,20*PU,3*PU,(4-self.ball_all)*PU,PU,PU);	//
			}else{
				g.setColor(Color.darkGray);
				g.fillRoundRect(4*PU,20*PU,3*PU,4*PU,PU,PU);	//
			}
			if(self.ball_red){
				g.setColor(Color.red);
				g.fillOval(4*PU,(23-self.ball_all)*PU,PU,PU);	//
			}
			if(self.ball_green){
				g.setColor(Color.green);
				g.fillOval(5*PU,(23-self.ball_all)*PU,PU,PU);	//
			}
			if(self.ball_blue){
				g.setColor(Color.blue);
				g.fillOval(6*PU,(23-self.ball_all)*PU,PU,PU);	//
			}
			//qɉ
			g.setColor(Color.white);
			g.drawLine(5*PU,20*PU,5*PU,24*PU);	//store
			g.drawLine(6*PU,20*PU,6*PU,24*PU);
			//
			//fobNp
			/*
			g.setFont(FONT_M_P);
			//
			g.setColor(Color.magenta);
			g.drawString("wWF@"+self.posx,18*PU,5*PU);
			g.drawString("xWF@"+self.posy,18*PU,6*PU);
			g.drawString("yWF@"+self.posz,18*PU,7*PU);
			g.drawString("pxF@@"+self.angle,18*PU,8*PU);
			//
			g.drawString("G@"+self.radius,18*PU,10*PU);
			g.drawString("⋋F@"+self.power_in*self.power_in_max,18*PU,11*PU);
			//
			g.drawString("ʌF@"+balls.area_data.size(),18*PU,13*PU);
			//
			g.drawString("wv\F@"+help_max,18*PU,15*PU);
			g.drawString("wvsF@"+help,18*PU,16*PU);
			//
			g.drawString("]Xs[hF@"+self.left_right,7*PU,5*PU);
			g.drawString("OXs[hF@"+self.ahead_back,7*PU,6*PU);
			g.drawString("㉺Xs[hF@"+self.up_down,7*PU,7*PU);
			//
			g.drawString("߂wF@"+balls.near_x,7*PU,9*PU);
			g.drawString("߂xF@"+balls.near_y,7*PU,10*PU);
			g.drawString("߂yF@"+balls.near_z,7*PU,11*PU);
			//
			g.drawString("KvF@"+ball_max,7*PU,13*PU);
			g.drawString("WρF@"+ball_num,7*PU,14*PU);
			*/
			//
			/*
			g.setColor(Color.red);
			for(int i=1;i<32;i++){
				g.drawLine(i*PU,0,i*PU,Kubomaki2Panel.F_HEIGHT);
				g.drawLine(0,i*PU,Kubomaki2Panel.F_WIDTH,i*PU);
			}
			*/
		//******************************************************
		}else{
			//
			switch(modePlay){
			case MP_OVER:	//over
				//hԂ
				g.setColor(Color.black);
				g.fillRect(0, 0, Kubomaki2Panel.F_WIDTH, Kubomaki2Panel.F_HEIGHT);
				//
				g.setColor(Color.gray);
				g.setFont(FONT_L_B);
				g.drawString("s",13*PU+2,8*PU+2);
				g.setFont(FONT_M_B);
				g.drawString("WʐF"+ball_num+"/"+ball_max+" ",12*PU+2,11*PU+2);
				g.drawString("c莞ԁF"+getTimeString(),12*PU+2,12*PU+2);
				g.drawString("~vF"+help+"/"+help_max+" ",12*PU+2,13*PU+2);
				g.setColor(Color.lightGray);
				g.setFont(FONT_L_B);
				g.drawString("s",13*PU,8*PU);
				g.setFont(FONT_M_B);
				g.drawString("WʐF"+ball_num+"/"+ball_max+" ",12*PU,11*PU);
				g.drawString("c莞ԁF"+getTimeString(),12*PU,12*PU);
				g.drawString("~vF"+help+"/"+help_max+" ",12*PU,13*PU);
				g.setColor(Color.gray);
				g.drawString("NbNŃX^[gʂ",11*PU,21*PU);
				break;
			case MP_CLEAR:	//clear
				//hԂ
				g.setColor(Color.orange);
				g.fillRect(0, 0, Kubomaki2Panel.F_WIDTH, Kubomaki2Panel.F_HEIGHT);
				//
				g.setColor(Color.black);
				g.setFont(FONT_L_B);
				g.drawString("ڕWB",9*PU+2,8*PU+2);
				g.setFont(FONT_M_B);
				g.drawString("WʐF"+ball_num+"/"+ball_max+" ",11*PU+2,11*PU+2);
				g.drawString("c莞ԁF"+getTimeString(),11*PU+2,12*PU+2);
				g.drawString("~vF"+help+"/"+help_max+" ",11*PU+2,13*PU+2);
				g.setColor(Color.white);
				g.setFont(FONT_L_B);
				g.drawString("ڕWB",9*PU,8*PU);
				g.setFont(FONT_M_B);
				g.drawString("WʐF"+ball_num+"/"+ball_max+" ",11*PU,11*PU);
				g.drawString("c莞ԁF"+getTimeString(),11*PU,12*PU);
				g.drawString("~vF"+help+"/"+help_max+" ",11*PU,13*PU);
				g.setColor(Color.yellow);
				g.drawString("NbNŃX^[gʂ",10*PU,21*PU);
				break;
			case MP_START:	//start
				//hԂ
				g.setColor(Color.darkGray);
				g.fillRect(0, 0, Kubomaki2Panel.F_WIDTH, Kubomaki2Panel.F_HEIGHT);
				//
				g.setFont(FONT_L_B);
				g.setColor(Color.orange);
				g.drawString("uN{}L̖`Qv",1*PU,8*PU);
				g.drawString("`StardustCollection`",0*PU,12*PU);
				g.setFont(FONT_M_B);
				g.setColor(Color.gray);
				g.drawString("NbNŃQ[Jn",10*PU,16*PU);
				if(data.checkMaked()){
					g.drawString("EscapeL[ŃXe[W쐬֖߂",10*PU,18*PU);
				}else{
					g.drawString("EscapeL[Ń^Cg֖߂",10*PU,18*PU);
				}
				break;
			}
		}
		//
	}
	//----------------------------------------------------------
	//tF[hCEtF[hAEg̏
	//----------------------------------------------------------
	public void setFade(int second,int type){
		//^Cvɍ킹ďݒ
		switch(type){
		case F_IN:	//IN
			setFadeFlag(true);
			fade_max=second*1000/time_fade;
			fade_now=0;
			fade_step=1;
			fade_continue=false;
			fade_color=Color.black;
			break;
		case F_OUT:	//OUT
			setFadeFlag(true);
			fade_max=second*1000/time_fade;
			fade_now=fade_max;
			fade_step=-1;
			fade_continue=false;
			fade_color=Color.white;
			break;
		case F_INOUT:	//INOUT
			setFadeFlag(true);
			fade_max=second*1000/time_fade;
			fade_now=0;
			fade_step=1;
			fade_continue=true;
			fade_color=Color.black;
			break;
		case F_OUTIN:	//OUTIN
			setFadeFlag(true);
			fade_max=second*1000/time_fade;
			fade_now=fade_max;
			fade_step=-1;
			fade_continue=true;
			fade_color=Color.white;
			break;
		}
	}
	public void checkFade(){
		//tF[hptOĂԁArunĂяo
		if(fade_step>0){	//IN
			if(fade_now>fade_max){
				if(fade_continue){		//IN->OUT
					fade_continue=false;
					fade_step=-1;
					fade_now+=2*fade_step;
					//
					int c=(int)(255*fade_now/fade_max);
					fade_color=new Color(c,c,c);
					fade_now+=fade_step;
				}else{					//I
					//
					switch(modePlay){
					case MP_WAIT:	//WAIT
						sounds.loopBGM(Kubomaki2Sound.BGM_REST);
						break;
					case MP_OVER:	//OVER
						sounds.playSE(Kubomaki2Sound.SE_OVER);
						break;
					case MP_CLEAR:	//CLEAR
						sounds.playSE(Kubomaki2Sound.SE_CLEAR);
						break;
					case MP_START:	//START
						sounds.loopBGM(Kubomaki2Sound.BGM_OPEN);
						break;
					}
					//tF[hptO낵čĕ`
					setFadeFlag(false);
					repaint();
					//ŌɎ~߂irun̒sĂj
					timerPlay.stop();
				}
			}else{		//
				//
				int c=(int)(255*fade_now/fade_max);
				fade_color=new Color(c,c,c);
				fade_now+=fade_step;
			}
		}else{				//OUT
			if(fade_now<0){
				if(fade_continue){		//OUT->IN
					fade_continue=false;
					fade_step=1;
					fade_now+=2*fade_step;
					//
					int c=(int)(255*fade_now/fade_max);
					fade_color=new Color(c,c,c);
					fade_now+=fade_step;
				}else{					//I
					//
					switch(modePlay){
					case MP_WAIT:	//WAIT
						sounds.loopBGM(Kubomaki2Sound.BGM_REST);
						break;
					case MP_OVER:	//OVER
						sounds.playSE(Kubomaki2Sound.SE_OVER);
						break;
					case MP_CLEAR:	//CLEAR
						sounds.playSE(Kubomaki2Sound.SE_CLEAR);
						break;
					case MP_START:	//START
						sounds.loopBGM(Kubomaki2Sound.BGM_OPEN);
						break;
					}
					//tF[hptO낵čĕ`
					setFadeFlag(false);
					repaint();
					//ŌɎ~߂irun̒sĂj
					timerPlay.stop();
				}
			}else{		//
				//
				int c=(int)(255*fade_now/fade_max);
				fade_color=new Color(c,c,c);
				fade_now+=fade_step;
			}
		}
	}
	private void setFadeFlag(boolean f){
		if(f){
			fade_flag=true;
			timerPlay.setDelay(time_fade);
		}else{
			fade_flag=false;
			timerPlay.setDelay(time_play);
		}
	}
	//----------------------------------------------------------
	//}EXCxg
	//----------------------------------------------------------
	public void mouseClicked(MouseEvent e){		//}EXNbN
		//L[Cxg󂯎邽߂ɃtH[JXĂ
		requestFocus();
		//tF[hȂ牽Ȃ
		if(fade_flag){	return;	}
		//***uSTARTvuOVERvuCLEARv--->uWAITṽQ[Jn***
		//vCłȂ΃vCJn
		if( modePlay==MP_START ){							//
			//
			formatData();
			//
			sounds.stopBGM();
			//
			modePlay=MP_WAIT;
			//
			setFade(3,F_IN);
			timerPlay.start();
		}else if( modePlay==MP_OVER || modePlay==MP_CLEAR ){		//
			//
			modePlay=MP_START;
			//
			setFade(2,F_INOUT);
			timerPlay.start();
		}
	}
	//----------------------------------------------------------
	//L[Cxg
	//----------------------------------------------------------
	public void keyPressed(KeyEvent e){	//L[
		//tF[hȂ牽Ȃ
		if(fade_flag){	return;	}
		//ɃQ[I[o[Ȃ牽ȂAsvH
		/*if( mode==OVER || mode==CLEAR || mode==START ){
			return;
		}*/
		//tO𗧂ĂiL[ňړAShiftL[ŔˁAZL[ŕj
        switch(e.getKeyCode()){
        case KeyEvent.VK_UP:		go_ahead=true;	break;	//L[
        case KeyEvent.VK_DOWN:		go_back=true;	break;	//L[
        case KeyEvent.VK_LEFT:		turn_left=true;	break;	//L[
        case KeyEvent.VK_RIGHT:	turn_right=true;break;	//EL[
        case KeyEvent.VK_SHIFT:	absorb=true;	break;	//VtgL[
        case KeyEvent.VK_Z:		go_up=true;		break;	//ZL[
        case KeyEvent.VK_X:		go_down=true;	break;	//XL[
		/*
		//fobOp
        case e.VK_C:								//CL[
			ball_num=ball_max;
			break;
		*/
        case KeyEvent.VK_SPACE:							//SpaceL[
			//***uPLAYv<---->uRESTv̐؂ւ***
			if(modePlay==MP_PLAY){
				timerPlay.stop();
				//
				sounds.stopBGM();
				//
				modePlay=MP_REST;
				panel.repaint();
			}else if(modePlay==MP_REST){
				timerPlay.start();
				//
				sounds.loopBGM(Kubomaki2Sound.BGM_PLAY);
				//
				modePlay=MP_PLAY;
			}
			break;
        case KeyEvent.VK_ENTER:							//EnterL[
			//***uPLAYv<---->uWAITv̐؂ւ***
			//***ʂW܂΁uPLAYv--->uCLEARv***
			if(modePlay==MP_WAIT){
				//wvXɍōŎˏo
				self.leave(balls);
				balls.checkArea(self);
				//
				modePlay=MP_PLAY;
				//
				timerPlay.start();
				//
				sounds.stopBGM();
				sounds.loopBGM(Kubomaki2Sound.BGM_PLAY);
			}else if(modePlay==MP_PLAY){
				if(self.radius<=2*balls.ball_space){
					ball_num+=self.ball_all;
					self.returnHome();
					balls.formatArea(self);
					//
					timerPlay.stop();
					//
					//bgm2.stop();
					sounds.stopBGM();
					//
					if(ball_num<ball_max){
						//
						modePlay=MP_WAIT;
						//
						setFade(2,F_IN);
					}else{
						//
						modePlay=MP_CLEAR;
						//
						setFade(3,F_IN);
					}
					//
					timerPlay.start();
				}
			}
			break;
         case KeyEvent.VK_DELETE:							//DeleteL[
			//***uPLAYv--->uWAITv̋~ov***
			//***񐔂ɒBuPLAYv--->uOVERv***
			//***ʂW܂΁uPLAYv--->uCLEARv***
			if(modePlay==MP_PLAY){
				timerPlay.stop();
				help+=1;
				ball_num+=self.ball_all;
				self.returnHome();
				balls.formatArea(self);
				//
				sounds.stopBGM();
				if(ball_num<ball_max){
					if(help<help_max){
						//
						modePlay=MP_WAIT;
						//
						setFade(1,F_OUTIN);
					}else{
						//
						modePlay=MP_OVER;
						//
						setFade(3,F_OUT);
					}
				}else{
					//
					modePlay=MP_CLEAR;
					//
					setFade(2,F_OUTIN);
				}
				timerPlay.start();
			}
			break;
         case KeyEvent.VK_ESCAPE:							//EscapeL[
			//***uPLAYv--->uSTARTv***
			if(modePlay==MP_PLAY){
				timerPlay.stop();
				sounds.stopBGM();
				//
				modePlay=MP_START;
				//
				setFade(2,F_INOUT);
				timerPlay.start();
			}else if(modePlay==MP_REST){
				//
				modePlay=MP_START;
				//
				setFade(2,F_INOUT);
				timerPlay.start();
			}else if(modePlay==MP_WAIT){
				sounds.stopBGM();
				//
				modePlay=MP_START;
				//
				setFade(2,F_INOUT);
				timerPlay.start();
			}else if(modePlay==MP_START){	//
				sounds.stopBGM();
				//
				if(data.checkMaked()){
					panel.backFromPlayToMake();
				}else{
					panel.backFromPlayToTitle();
				}
			}
			break;
       }
    }
	public void keyReleased(KeyEvent e){	//L[
		//ɃQ[I[o[Ȃ牽ȂAsvH
		/*if( mode==OVER || mode==CLEAR || mode==START ){
			return;
		}*/
		//tO낷
        switch(e.getKeyCode()){
        case KeyEvent.VK_UP:		go_ahead=false;		break;	//L[
        case KeyEvent.VK_DOWN:		go_back=false;		break;	//L[
        case KeyEvent.VK_LEFT:		turn_left=false;	break;	//L[
        case KeyEvent.VK_RIGHT:	turn_right=false;	break;	//EL[
        case KeyEvent.VK_SHIFT:	absorb=false;		break;	//VtgL[
        case KeyEvent.VK_Z:		go_up=false;		break;	//ZL[
        case KeyEvent.VK_X:		go_down=false;		break;	//XL[
		}
	}
	//------------------------------------------------
	//TimeȑimodePLAY̎ƃtF[h̎j
	//------------------------------------------------
	public void actionPerformed(ActionEvent ae) {
		//
		//******************************************************modePLAY̎
		if(!fade_flag){
			//********* modePLAY̎̂ *********
			//itF[hIcheckFade̒ŎsĂ܂Hj
			//if(mode!=PLAY){	continue;	}
			if(modePlay!=MP_PLAY){	return;	}
			//**************************************
			//------
			timer_second=(timer_second*1000-time_play)/1000;	//modePLAŶ͂
			if(timer_second<=0){
				//***uPLAYv--->uOVERv***
				//
				sounds.stopBGM();
				//
				modePlay=MP_OVER;
				timer_second=0;
				//
				setFade(3,F_OUT);
			}
			//---@Ƌ---
			self.power_out=0;
			self.setSpeed(turn_right,turn_left,go_ahead,go_back,go_up,go_down);
			if(absorb){
				self.setStore(balls,sounds);	//ړO
			}
			self.setPosition();
			self.setPower();
			switch( balls.checkArea(self) ){
			case P_IN_AREA:	//IN_AREA
				break;
			case P_HOME:	//HOME
				//***uPLAYv--->uWAITv***
				//***ʂW܂΁uPLAYv--->uCLEARv***
				ball_num+=self.ball_all;
				self.returnHome();
				balls.formatArea(self);
				//
				sounds.stopBGM();
				//
				if(ball_num<ball_max){
					//
					modePlay=MP_WAIT;
					//
					setFade(2,F_IN);
				}else{
					//
					modePlay=MP_CLEAR;
					//
					setFade(3,F_IN);
				}
				break;
			case P_OUT_AREA:	//OUT_AREA
				break;
			case P_LAND:	//LAND
				//***uPLAYv--->uWAITv̋~ov***
				//***񐔂ɒBuPLAYv--->uOVERv***
				//***ʂW܂΁uPLAYv--->uCLEARv***
				help+=1;
				ball_num+=self.ball_all;
				self.returnHome();
				balls.formatArea(self);
				//
				sounds.stopBGM();
				if(ball_num<ball_max){
					if(help<help_max){
						//
						modePlay=MP_WAIT;
						//
						setFade(1,F_OUTIN);
					}else{
						//
						modePlay=MP_OVER;
						//
						setFade(3,F_OUT);
					}
				}else{
					//
					modePlay=MP_CLEAR;
					//
					setFade(2,F_OUTIN);
				}
				break;
			}
			//---̈ړ---
			for(int i=0;i<star_num;i++){
				//
				star1[i].width+=(int)(star_speed*self.left_right);
				star2[i].width+=(int)(star_speed*self.left_right);
				star1[i].height+=(int)(star_speed*self.up_down);
				star2[i].height+=(int)(star_speed*self.up_down);
				int s=(int)(star_speed*self.ahead_back);
				star1[i].width-=s;
				if( star1[i].height < (star1_rect.getSize()).height/2 ){
					star1[i].height-=(int)(s/2);
				}else{
					star1[i].height+=(int)(s/2);
				}
				star2[i].width+=s;
				if( star2[i].height < (star2_rect.getSize()).height/2 ){
					star2[i].height-=(int)(s/2);
				}else{
					star2[i].height+=(int)(s/2);
				}
				//
				if( !(star1_rect.contains(star1[i].width,star1[i].height)) ){
					star1[i].width=(int)((star1_rect.getSize()).width*Math.random());
					star1[i].height=(int)((star1_rect.getSize()).height*Math.random());
				}
				if( !(star2_rect.contains(star2[i].width,star2[i].height)) ){
					star2[i].width=(int)((star2_rect.getSize()).width*Math.random())+(star2_rect.getLocation()).x;
					star2[i].height=(int)((star2_rect.getSize()).height*Math.random());
				}
			}
		//******************************************************tF[h̎
		}else{
			//
			checkFade();
		}
		//ĕ`
        panel.repaint();
	}
}
