import java.applet.Applet;
import java.applet.AudioClip;
import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;

//ʉ̊ǗAt̃NXčs
public class Kubomaki2Sound
{
	//----------------------------------
	//ʉ̎
	static final int SE_ABSORB=0;	//
	static final int SE_COMPOSE=1;	//
	static final int SE_ALERT=2;	//
	static final int SE_OVER=3;		//
	static final int SE_CLEAR=4;	//
	//
	static final int SE_ALL=5;
	//BGM̎
	static final int BGM_OPEN=0;	//
	static final int BGM_REST=1;	//
	static final int BGM_PLAY=2;	//
	//
	static final int BGM_ALL=3;
	//
	static final String[] SE_NAME={"absorb","compose","alert","over","clear",};
	static final String[] BGM_NAME={"bgm_open","bgm_rest","bgm_play",};
	//t@CtH_
	static final String FOLDER="audio";
	//---------------------------------
	//
	AudioClip bgm[];
	AudioClip soundEffect[];
	//p[^[Ŏw肳鉉ttO
	boolean sePlayFlag;
	boolean bgmPlayFlag;
	//-------------------------------------
	//
	public Kubomaki2Sound(){
		//
		//***ʉ***
		//
		sePlayFlag=true;
		soundEffect=new AudioClip[SE_ALL];
		if(sePlayFlag){
			for(int s=0;s<SE_ALL;s++){
				soundEffect[s]=getInnerAudioClip(/*data.SE*/FOLDER+"/"+SE_NAME[s]+".au");
			}
		}
		//***BGM***
		//
		bgmPlayFlag=true;
		bgm=new AudioClip[BGM_ALL];
		if(bgmPlayFlag){
			for(int s=0;s<BGM_ALL;s++){
				bgm[s]=getInnerAudioClip(/*data.SE*/FOLDER+"/"+BGM_NAME[s]+".au");
			}
		}
	}
	//-------------------------------------
	//t@C̓ǂݍ
	//-------------------------------------
	public void formatSound(Kubomaki2Data data){
		if(bgmPlayFlag){
			//
			if(data.checkMaked()){	//Xe[W쐬̏ꍇAÕt@C`FbN
				for(int s=0;s<BGM_ALL;s++){
					bgm[s]=getOuterAudioClip(FOLDER+"/"+BGM_NAME[s],FOLDER+"/"+BGM_NAME[s]+".au");
				}
			}else{					//pӂꂽXe[W̏ꍇÃt@C
				for(int s=0;s<BGM_ALL;s++){
					bgm[s]=getInnerAudioClip(FOLDER+"/"+BGM_NAME[s]+".au");
				}
			}
		}
		if(sePlayFlag){
			if(data.checkMaked()){
				for(int s=0;s<SE_ALL;s++){
					soundEffect[s]=getOuterAudioClip(FOLDER+"/"+SE_NAME[s],data.se+"/"+SE_NAME[s]+".au");
				}
			}else{
				for(int s=0;s<SE_ALL;s++){
					soundEffect[s]=getInnerAudioClip(data.se+"/"+SE_NAME[s]+".au");
				}
			}
		}
	}
	//
	private AudioClip getInnerAudioClip(String innerPathAll){
		//
		URL url=getClass().getResource(innerPathAll);
		return Applet.newAudioClip(url);
	}
	//OAȂΓ
	private AudioClip getOuterAudioClip(String outerPathNoEx,String innerPathAll){
		File file=getAudioFile(outerPathNoEx);
		if(file!=null){
			try{
				return Applet.newAudioClip(file.toURI().toURL());
			}catch(MalformedURLException e){
				return getInnerAudioClip(innerPathAll);	//G[Ȃ
			}

		}else{
			return getInnerAudioClip(innerPathAll);	//OɂȂΓ
		}
	}
	//Ot@C̗L`FbN
	private File getAudioFile(String outerPathNoEx){
		File file;
		//DxP
		file=new File(/*System.getProperty("user.dir")+"/"+*/outerPathNoEx+".au");
		if(file.exists()){	return file;	}
		//DxQ
		file=new File(/*System.getProperty("user.dir")+"/"+*/outerPathNoEx+".wav");
		if(file.exists()){	return file;	}
		//DxR
		file=new File(/*System.getProperty("user.dir")+"/"+*/outerPathNoEx+".mid");
		if(file.exists()){	return file;	}
		//
		return null;
	}
	//-------------------------------------
	//tp
	//-------------------------------------
	public synchronized void playSE(int seNum){
		if(!sePlayFlag){	return;	}
		//
		if(seNum<SE_ALL){
			soundEffect[seNum].play();
		}
	}
	public void loopBGM(int bgmNum){
		if(!bgmPlayFlag){	return;	}
		//
		if(bgmNum<BGM_ALL){
			bgm[bgmNum].loop();
		}
	}
	public void stopBGM(){
		if(!bgmPlayFlag){	return;	}
		//
		for(int b=0;b<BGM_ALL;b++){
			bgm[b].stop();
		}
	}
}
